#version 330

in vec3 position;
in vec3 normal;
in vec2 uvs;

out vec3 worldNormal;
out vec2 fUVs;

out vec3 worldPosition;
out vec3 normalCamera;
out vec3 eyeDirection;
out vec3 lightDirection;
out vec4 shadowCoord;

uniform mat4 projectionMatrix;
uniform mat4 M;
uniform mat4 VP;
uniform mat4 V;
uniform vec3 lightPosition;
uniform mat4 depthBiasMVP;


void main()
{	
	fUVs = uvs;
	worldNormal = (M * vec4(normal, 0)).xyz;
	worldPosition = (M * vec4(position,1)).xyz;
	gl_Position = VP * M * vec4(position,1);

	shadowCoord = depthBiasMVP * M * vec4(position,1);

	vec3 vPositionCamera = (V * M * vec4(position,1)).xyz;
	eyeDirection = vec3(0,0,0) - vPositionCamera;

	vec3 lPositionCamera = (V * M * vec4(lightPosition,1)).xyz;
	lightDirection = lPositionCamera + eyeDirection;

	normalCamera = (V * M * vec4(normal,0)).xyz;
}

