#version 330

in vec3 position;
in vec3 normal;
in vec2 uvs;
in vec3 tangents;
in vec3 bittangents;

out vec3 worldNormal;
out vec2 fUVs;

out vec3 worldPosition;
out vec3 eyeDirectionTangent;
out vec3 lightDirectionTangent;

uniform mat4 projectionMatrix;
uniform mat4 M;
uniform mat4 VP;
uniform mat4 V;
uniform vec3 lightPosition;

void main()
{	
	fUVs = uvs;
	worldNormal = (M * vec4(normal, 0)).xyz;
	worldPosition = (M * vec4(position,1)).xyz;
	gl_Position = VP * M * vec4(position,1);

	vec3 vPositionCamera = (V * M * vec4(position,1)).xyz;
	vec3 eyeDirection = vec3(0,0,0) - vPositionCamera;

	vec3 lPositionCamera = (V * M * vec4(lightPosition,1)).xyz;
	vec3 lightDirection = lPositionCamera + eyeDirection;

	mat4 MV = V * M;
	mat3 MV3 = mat3(MV);

	vec3 normalCamera = MV3 * normal;
	vec3 tangentCamera =  MV3 * tangents;
	vec3 bittangentCamera =  MV3 * bittangents;
	
	mat3 TBN = transpose(mat3(
		tangentCamera,
		bittangentCamera,
		normalCamera	
	));

	lightDirectionTangent = TBN * lightDirection;
	eyeDirectionTangent = TBN * eyeDirection;

}

